<?php
/**
 * This script generate a gif file representing
 * the font ($szFontToDisplay) from font file.
 * Font file is set by registered variable
 * $FontFileRef
 *
 * @project     MapEdit
 * @revision    $Id: font.php,v 1.8.2.1 2003/09/18 02:16:11 pspencer Exp $
 * @purpose     Generate a font preview image
 * @author      Paul Spencer (spencer@dmsolutions.ca)
 * @copyright
 * <b>Copyright (c) 2002, DM Solutions Group Inc.</b>
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
//turn off cookies for propagation of session ids
include_once( "../common/session/session.php" );
installSessionDirectoryHandler();
initializeSession();

/* -------------------------------------------------------------------- */
/*      Load required modules                                           */
/* -------------------------------------------------------------------- */
if (PHP_OS == "WINNT" || PHP_OS == "WIN32")
{
    if (!extension_loaded( "gd" ))
    {
        if (!@dl( "php_gd.dll" ))
            dl("php_gd2.dll");
    }
}
else
{
    if (!extension_loaded("gd"))
    {
        if (!@dl( "php_gd.so" ))
            dl("php_gd2.so");
    }
}

$nX = 160;
$nY = 24;
$nFontSize = 10;
$szFontToDisplay = $_GET["szFontName"];
// If no font specify, display a empty gif.
if ($szFontToDisplay == "NONE" || $szFontToDisplay == "" ||
    !isset($_SESSION["gszFontFile"]))
    $bDrawX = true;
else
    $bDrawX = false;

// Create the image
$nImgId = ImageCreate($nX, $nY);

//allocate drawing colors
$nXColor = ImageColorAllocate( $nImgId, 255, 0, 0);
$nRed = (isset($_GET["nRed"])) ? $_GET["nRed"] : 0;
$nGreen = (isset($_GET["nGreen"])) ? $_GET["nGreen"] : 0;
$nBlue = (isset($_GET["nBlue"])) ? $_GET["nBlue"] : 0;

$nFillColor = ImageColorAllocate ($nImgId, $nRed, $nGreen, $nBlue);
$nShadowColor = ImageColorAllocate( $nImgId, 64, 64, 64 );
$nHiliteColor = ImageColorAllocate( $nImgId, 224, 224, 224 );
$nFaceColor = ImageColorAllocate( $nImgId, 192, 192, 192 );
$nTriangleColor = ImageColorAllocate($nImgId, 0,0,0);
$nWhite = ImageColorAllocate($nImgId, 255, 255, 255 );

//fill up the rectange with the face color and draw everything
//else on top
ImageFilledRectangle($nImgId, 0, 0, $nX - 1, $nY - 1, $nFaceColor);
ImageFilledRectangle($nImgId, 3, 3, $nX - 4, $nY - 4, $nWhite );

if ($bDrawX)
{
    //no, draw a red X
    $nCX = intval(( $nX - 1 ) / 2);
    $nCY = intval(( $nY - 1 ) / 2);
    ImageFilledRectangle( $nImgId, 3, 3, $nX - 4, $nY - 4, $nWhite );
    ImageLine( $nImgId, $nCX-3, $nCY-3, $nCX+3, $nCY+3, $nXColor );
    ImageLine( $nImgId, $nCX-2, $nCY-3, $nCX+4, $nCY+3, $nXColor );
    ImageLine( $nImgId, $nCX+3, $nCY-3, $nCX-3, $nCY+3, $nXColor );
    ImageLine( $nImgId, $nCX+4, $nCY-3, $nCX-2, $nCY+3, $nXColor );
}
else
{
    // Open the whole file
    $aszTmpFontList = file($_SESSION["gszFontFile"]);
    $aszFontList = array();

    $szFontList = "";

    // Parse each line of the font file
    foreach ($aszTmpFontList as $szFont)
    {
        // Extract the font name
        $szFontName = trim($szFont, " ");
        $szFontName = preg_replace("/\s+/", "|", $szFontName);
        $aszFontName = explode("|", $szFontName);
        $szFontName = $aszFontName[0];
        if ($szFontName ==  $szFontToDisplay)
        {
            // Extrack the font file name
            $szFontToDisplay = $aszFontName[1];
            // Get bounding box of text
            $ttfBBox =  imagettfbbox ($nFontSize, 0,
                                      dirname($_SESSION["gszFontFile"])."/".
                                      $szFontToDisplay,
                                      $szFontName);
            $nFontHeight = abs($ttfBBox[7] - $ttfBBox[3]);
            $nFontWidth = abs($ttfBBox[6] - $ttfBBox[2]);
            $nLabelX = ($nX - $nFontWidth) / 2;
            $nLabelY = ($nY + $nFontHeight - 4) / 2;
            // Test will be black
            $text_color = ImageColorAllocate ($nImgId, 0, 0, 0);

            // Draw text. Use font name for sample text
            ImageTTFText($nImgId, $nFontSize, 0, $nLabelX, $nLabelY, $text_color,
                         dirname($_SESSION["gszFontFile"])."/".$szFontToDisplay,
                         $szFontName);

        }
   }
}
//draw the small face colored box for the drop down triangle
ImageFilledRectangle($nImgId, $nX-8, $nY-6, $nX-1, $nY-1, $nFaceColor);


ImageLine( $nImgId, 0, 0, $nX-1, 0, $nHiliteColor);
ImageLine( $nImgId, 0, 0, 0, $nY-1, $nHiliteColor);
ImageLine( $nImgId, $nX-1, $nY-1, $nX-1, 0, $nShadowColor);
ImageLine( $nImgId, $nX-1, $nY-1, 0, $nY-1, $nShadowColor);
ImageLine( $nImgId, 2, 2, 2, $nY - 3, $nShadowColor );
ImageLine( $nImgId, 2, 2, $nX - 3, 2, $nShadowColor );
ImageLine( $nImgId, $nX-3, 2, $nX-3, $nY-7, $nHiliteColor );
ImageLine( $nImgId, 2, $nY-3, $nX-9, $nY-3, $nHiliteColor );
ImageLine( $nImgId, $nX-9, $nY-7, $nX-3, $nY-7, $nHiliteColor );
ImageLine( $nImgId, $nX-9, $nY-7, $nX-9, $nY-3, $nHiliteColor );

$anPoints = array();
$anPoints[0] = $nX - 7;
$anPoints[1] = $nY - 5;
$anPoints[2] = $nX - 3;
$anPoints[3] = $nY - 5;
$anPoints[4] = $nX - 5;
$anPoints[5] = $nY - 3;
ImageFilledPolygon( $nImgId, $anPoints, 3, $nTriangleColor);

if (!isset($_SESSION["gszImageType"]))
{
    header("Content-type: image/png");
    ImagePng($nImgId);
}
else
{
    header("Content-type: image/".$_SESSION["gszImageType"]);
    eval("Image".$_SESSION["gszImageType"]."(\$nImgId);");
}

ImageDestroy( $nImgId );
?>

